;
; Ascending sort of an array of unsigned integers
;

format ELF64

section '.data' writeable
arrlen  equ     20
arr     dw      400, 700, 200, 450, 900, 300, 800, 100, 150, 650, 250, 950, 850, 350, 550, 600, 500, 400, 750, 200
frmat   db      "%3u  ", 0
eol     db      0Dh, 0Ah, 0

section '.bss' writeable
savcnt  dq      ?
savarr  dq      ?
savlen  dq      ?

section '.text' executable
public main
extrn printf
main:
        push    rbp
        mov     rbp, rsp;
        sub     rsp, 32
        and     rsp, -16
        mov     rcx, arrlen
        lea     rdx, [arr]
        call    print_arr
        mov     cl, 0
        lea     esi, [arr]
outer:
        mov     edi, esi
        add     edi, 2
        mov     dl, cl
        inc     dl
inner:
        mov     word ax, [esi]
        mov     word bx, [edi]
        cmp     ax, bx
        jle     continue
        mov     [esi], bx
        mov     [edi], ax
continue:
        add     edi, 2
        inc     dl
        cmp     dl, arrlen
        jl      inner
        add     esi, 2
        inc     cl
        cmp     cl, arrlen - 1
        jl      outer
        mov     rcx, arrlen
        lea     rdx, [arr]
        call    print_arr
        mov     rsp, rbp
        pop     rbp
        xor     rax, rax
        ret

;
; Display all elements of an array of unsigned integers
;
; Input:     RCX: Array length
;            RDX: Array base address
; Output:    -----
; Functions: printf (external C function)
;
print_arr:
        sub     rsp, 32
        push    rax
        push    rbx
        mov     rbx, 0
print:
        cmp     rbx, rcx
        je      print_arr_end
        xor     rax, rax
        mov     word ax, [rdx+rbx*2]
        inc     rbx
        mov     [savlen], rcx
        mov     [savcnt], rbx
        mov     [savarr], rdx
        mov     rcx, frmat
        mov     rdx, rax
        call    printf
        mov     rcx, [savlen]
        mov     rbx, [savcnt]
        mov     rdx, [savarr]
        jmp     print
print_arr_end:
        mov     rcx, eol
        call    printf
        pop     rbx
        pop     rax
        add     rsp, 32
        ret
