;
; Ascending sort of an array of signed integers entered by the user
;

format ELF64

section '.data' writeable
maxlen  equ     50
asktxt  db      "Enter a series of integers, terminated by 0", 0Dh, 0Ah, 0
asknum  db      "? ", 0
frmatin db      "%lli", 0
frmat   db      "%lli  ", 0
eol     db      0Dh, 0Ah, 0

section '.bss' writeable
array   dq      50 dup (?)
arrlen  dq      ?
num     dq      ?
savlen  dq      ?
savlen2 dq      ?
savcnt  dq      ?
savarr  dq      ?

section '.text' executable
public main
extrn printf
extrn scanf
main:
        push    rbp
        mov     rbp, rsp;
        sub     rsp, 32
        and     rsp, -16
        mov     rcx, asktxt
        call    printf
        mov     rcx, maxlen
        lea     rdx, [array]
        call    array_input
        cmp     rax, 2
        jl      main_end
        mov     [arrlen], rax
        mov     rcx, [arrlen]
        lea     rdx, [array]
        call    array_print
        mov     rcx, [arrlen]
        lea     rdx, [array]
        call    array_sort
        mov     rcx, [arrlen]
        lea     rdx, [array]
        call    array_print
main_end:
        mov     rsp, rbp
        pop     rbp
        xor     rax, rax
        ret

;
; Enter a series of signed integers from the keybord and
; store these numbers into an array. Input is terminated
; by entering 0 (this 0 will not be included in the array)
;
; Input:     RCX: Maximum array length
;            RDX: Array base address
; Output:    RAX: Actual array length
;            The array will be filled with the numbers entered
; Functions: printf, scanf (external C functions)
;
array_input:
        sub     rsp, 32
        mov     [savlen], rcx
        mov     [savarr], rdx
        mov     rcx, 0
.input_next:
        cmp     rcx, [savlen]
        je      array_input_end
        mov     [savcnt], rcx
        mov     rcx, asknum
        call    printf
        mov     rcx, frmatin
        mov     rdx, num
        call    scanf
        mov     rax, [num]
        cmp     rax, 0
        je      array_input_end
        mov     rcx, [savcnt]
        mov     rdx, [savarr]
        mov     [rdx+rcx*8], rax
        inc     rcx
        jmp     .input_next
array_input_end:
        mov     rax, [savcnt]
        add     rsp, 32
        ret

;
; Sort an array of signed integers
;
; Input:  RCX: Array length
;         RDX: Array base address
; Output: -----
;         The array elements will be sorted
;
array_sort:
        mov     [savlen], rcx
        dec     rcx
        mov     [savlen2], rcx
        mov     rsi, rdx
        mov     rcx, 0
.sort_outer:
        mov     rdi, rsi
        add     rdi, 8
        mov     rdx, rcx
        inc     rdx
.sort_inner:
        mov     rax, [rsi]
        mov     rbx, [rdi]
        cmp     rax, rbx
        jle     .sort_continue
        mov     [rsi], rbx
        mov     [rdi], rax
.sort_continue:
        add     rdi, 8
        inc     rdx
        cmp     rdx, [savlen]
        jl      .sort_inner
        add     rsi, 8
        inc     rcx
        cmp     rcx, [savlen2]
        jl      .sort_outer
array_sort_end:
        ret

;
; Display all elements of an array of signed integers
;
; Input:     RCX: Array length
;            RDX: Array base address
; Output:    -----
; Functions: printf (external C function)
;
array_print:
        sub     rsp, 32
        push    rax
        push    rbx
        mov     rbx, 0
.print:
        cmp     rbx, rcx
        je      array_print_end
        mov     rax, [rdx+rbx*8]
        inc     rbx
        mov     [savlen], rcx
        mov     [savcnt], rbx
        mov     [savarr], rdx
        mov     rcx, frmat
        mov     rdx, rax
        call    printf
        mov     rcx, [savlen]
        mov     rbx, [savcnt]
        mov     rdx, [savarr]
        jmp     .print
array_print_end:
        mov     rcx, eol
        call    printf
        pop     rbx
        pop     rax
        add     rsp, 32
        ret
