;
; Elements of a matrix
;

format ELF64

section '.data' writeable
rows    equ     3
cols    equ     4
dsize   equ     2
matrix  dw      0, 1, 2, 3
        dw      10, 11, 12, 13
        dw      20, 21, 22, 23
frmat1  db      "Matrix element M[1, 2] = %u", 0Dh, 0Ah, 0
frmat2  db      "Matrix element M[2, 1] = %u", 0Dh, 0Ah, 0

section '.text' executable
public main
extrn printf
main:
        push    rbp
        mov     rbp, rsp;
        sub     rsp, 32
        and     rsp, -16
        mov     rax, 1
        mov     rbx, 2
        mov     rcx, cols
        mov     rdx, dsize
        call    element_offset
        mov     rcx, frmat1
        xor     rdx, rdx
        mov     word dx, [matrix+rax]
        call    printf
        mov     rax, 2
        mov     rbx, 1
        mov     rcx, cols
        mov     rdx, dsize
        call    element_offset
        mov     rcx, frmat2
        xor     rdx, rdx
        mov     word dx, [matrix+rax]
        call    printf
        mov     rsp, rbp
        pop     rbp
        xor     rax, rax
        ret

;
; Calculate two dimensional arry element offset
;
; Input:  RAX: Row-index
;         RBX: Column-index
;         RCX: Number of columns in array
;         RDX: Size of elements data type
; Output: RAX: element offset

element_offset:
        push    rdx
        imul    rcx
        add     rax, rbx
        pop     rdx
        imul    rdx
        ret
