;
; Minimum and maximum of an array of signed integers using functions
;

format ELF64

section '.data' writeable
arrlen  equ     20
arr     dq      1, -4, -7, 2, -9, 3, -3, -6, 0, 6, 5, -1, 4, 7, -2, 9, -5, 8, -8, 0
frmat1  db      "Minimum value in array: %d", 0Dh, 0Ah, 0
frmat2  db      "Maximum value in array: %d", 0Dh, 0Ah, 0

section '.text' executable
public main
extrn printf
main:
        push    rbp
        mov     rbp, rsp;
        sub     rsp, 32
        and     rsp, -16
        mov     cl, arrlen
        lea     esi, [arr]
        call    min
        mov     rcx, frmat1
        call    printf
        mov     cl, arrlen
        lea     esi, [arr]
        call    max
        mov     rcx, frmat2
        call    printf
        mov     rsp, rbp
        pop     rbp
        xor     rax, rax
        ret

;
; Minimum of an array of signed integers
;
; Input:  ESI: Pointer to array
;         CL : Number of array elements
; Output: RDX: Minimum

min:
        push    rax
        mov     qword rdx, [esi]
        dec     cl
minnext:
        add     esi, 8
        mov     qword rax, [esi]
        cmp     rdx, rax
        jle     mincont
        mov     rdx, rax
mincont:
        dec     cl
        cmp     cl, 0
        jne     minnext
        pop     rax
        ret

;
; Maximum of an array of signed integers
;
; Input:  ESI: Pointer to array
;         CL : Number of array elements
; Output: RDX: Maximum

max:
        push    rax
        mov     qword rdx, [esi]
        dec     cl
maxnext:
        add     esi, 8
        mov     qword rax, [esi]
        cmp     rdx, rax
        jge     maxcont
        mov     rdx, rax
maxcont:
        dec     cl
        cmp     cl, 0
        jne     maxnext
        pop     rax
        ret
