;
; Minimum and maximum of an array of floating point numbers using procedures
;

format ELF64

section '.data' writeable
arrlen  equ      20
arr     dq       1.5, -5.5, 4.2, -2.4, -6.8, 7.8, 2.4, -0.7, 9.5, 3.3, -1.7, -4.4, 8.7, 6.2, -7.7, -0.1, 5.4, 0.4, -9.5, -6.6
frmat1  db       "Minimum value in array: %.2f", 0Dh, 0Ah, 0
frmat2  db       "Maximum value in array: %.2f", 0Dh, 0Ah, 0

section '.text' executable
public main
extrn printf
main:
        push     rbp
        mov      rbp, rsp;
        sub      rsp, 32
        and      rsp, -16
        mov      cl, arrlen
        lea      esi, [arr]
        call     min
        movq     rdx, xmm0
        mov      rcx, frmat1
        call     printf
        mov      cl, arrlen
        lea      esi, [arr]
        call     max
        movq     rdx, xmm0
        mov      rcx, frmat2
        call     printf
        mov      rsp, rbp
        pop      rbp
        xor      rax, rax
        ret

;
; Minimum of an array of floating point numbers
;
; Input:     ESI:  Pointer to array
;            CL:   Number of array elements
; Output:    XMM0: Minimum
; Registers: XMM1 and XMM2 are changed!

min:
        push     rax
        movsd    xmm0, [esi]
        dec      cl
minnext:
        add      esi, 8
        movsd    xmm1, [esi]
        movsd    xmm2, xmm1
        cmpnltsd xmm2, xmm0
        movd     eax, xmm2
        test     eax, eax
        jnz      mincont
        movsd    xmm0, xmm1
mincont:
        dec      cl
        cmp      cl, 0
        jne      minnext
        pop      rax
        ret

;
; Maximum of an array of floating point numbers
;
; Input:  ESI:  Pointer to array
;         CL:   Number of array elements
; Output: XMM0: Maximum
; Registers: XMM1 and XMM2 are changed!

max:
        push     rax
        movsd    xmm0, [esi]
        dec      cl
maxnext:
        add      esi, 8
        movsd    xmm1, [esi]
        movsd    xmm2, xmm1
        cmplesd  xmm2, xmm0
        movd     eax, xmm2
        test     eax, eax
        jnz      maxcont
        movsd    xmm0, xmm1
maxcont:
        dec      cl
        cmp      cl, 0
        jne      maxnext
        pop      rax
        ret
