;
; Random number distribution (number counts)
;

format ELF64

section '.data' writeable
nums    equ     18000
nlow    equ     1
nhigh   equ     9
ncounts equ     9
count   dq      0
counts  dq      9 dup 0
frmat   db      "%1llu: %4llu times", 0Dh, 0Ah, 0

section '.text' executable
public main
extrn printf
main:
        push    rbp
        mov     rbp, rsp;
        sub     rsp, 32
        and     rsp, -16
        mov     rcx, 0
rand_next:
        cmp     rcx, nums
        je      counts_display
rand_try:
        rdrand  rax
        jnc     rand_try
        xor     rdx, rdx
        mov     rbx, nhigh - nlow + 1
        div     rbx
        add     rdx, nlow
        lea     rbx, [counts]
        inc     qword [rbx+(rdx-1)*8]
        inc     rcx
        jmp     rand_next
counts_display:
        mov     rcx, 0
display_next:
        cmp     rcx, ncounts
        je      done
        lea     rbx, [counts]
        inc     rcx
        mov     [count], rcx
        mov     r8, [rbx+(rcx-1)*8]
        mov     rdx, rcx
        mov     rcx, frmat
        call    printf
        mov     rcx, [count]
        jmp     display_next
done:
        mov     rsp, rbp
        pop     rbp
        xor     rax, rax
        ret
