;
; Squares of the elements of an array of unsigned integers ("squares" subroutine)
;

format ELF64

section '.data' writeable
arrlen  equ     20
arr     dw      1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20
count   dq      0
frmat   db      "%3u  ", 0
eol     db      0Dh, 0Ah, 0

section '.bss' writeable
arr2    dw      20 dup (?)

section '.text' executable
public main
extrn printf
main:
        push    rbp
        mov     rbp, rsp;
        sub     rsp, 32
        and     rsp, -16
        lea     esi, [arr]
        lea     edi, [arr2]
        mov     cl, arrlen
        call    square
        mov     rcx, 0
print1:
        cmp     rcx, arrlen
        je      continue
        xor     rax, rax
        mov     word ax, [arr+rcx*2]
        inc     rcx
        mov     [count], rcx
        mov     rcx, frmat
        mov     rdx, rax
        call    printf
        mov     rcx, [count]
        jmp print1
continue:
        mov     rcx, eol
        call    printf
        mov     rcx, 0
print2:
        cmp     rcx, arrlen
        je      done
        xor     rax, rax
        mov     word ax, [arr2+rcx*2]
        inc     rcx
        mov     [count], rcx
        mov     rcx, frmat
        mov     rdx, rax
        call    printf
        mov     rcx, [count]
        jmp print2
done:
        mov     rsp, rbp
        pop     rbp
        xor     rax, rax
        ret


;
; Squares of the elements of an array of unsigned integers
;
; Input:  ESI: Pointer to original array
;         EDI: Pointer to squares array
;         CL:  Number of array elements
; Output: The squares array will be filled
;
square:
        push    rax
        push    rbx
        mov     bl, 0
next:
        cmp     bl, cl
        je      square_end
        mov     word ax, [esi]
        imul    ax
        mov     word [edi], ax
        add     esi, 2
        add     edi, 2
        inc     bl
        jmp     next
square_end:
        pop     rbx
        pop     rax
        ret
