;
; Squares of the elements of an array of unsigned integers ("display" subroutine)
;

format ELF64

section '.data' writeable
arrlen  equ     20
arr     dw      1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20
frmat   db      "%3u  ", 0
eol     db      0Dh, 0Ah, 0

section '.bss' writeable
arr2    dw      20 dup (?)
savcnt  dq      ?
savarr  dq      ?
savlen  dq      ?

section '.text' executable
public main
extrn printf
main:
        push    rbp
        mov     rbp, rsp;
        sub     rsp, 32
        and     rsp, -16
        mov     rcx, 0
next:
        cmp     rcx, arrlen
        je      continue
        mov     word ax, [arr+rcx*2]
        imul    ax
        mov     word [arr2+rcx*2], ax
        inc     rcx
        jmp     next
continue:
        mov     rcx, arrlen
        lea     rdx, [arr]
        call    print_arr
        mov     rcx, arrlen
        lea     rdx, [arr2]
        call    print_arr
        mov     rsp, rbp
        pop     rbp
        xor     rax, rax
        ret

;
; Display all elements of an array of unsigned integers
;
; Input:     RCX: Array length
;            RDX: Array base address
; Output:    -----
; Functions: printf (external C function)
;
print_arr:
        sub     rsp, 32
        push    rax
        push    rbx
        mov     rbx, 0
print:
        cmp     rbx, rcx
        je      print_arr_end
        xor     rax, rax
        mov     word ax, [rdx+rbx*2]
        inc     rbx
        mov     [savlen], rcx
        mov     [savcnt], rbx
        mov     [savarr], rdx
        mov     rcx, frmat
        mov     rdx, rax
        call    printf
        mov     rcx, [savlen]
        mov     rbx, [savcnt]
        mov     rdx, [savarr]
        jmp     print
print_arr_end:
        mov     rcx, eol
        call    printf
        pop     rbx
        pop     rax
        add     rsp, 32
        ret
